package pl.rmalinowski.gwtreflect.client.utils;

import com.google.gwt.core.client.JavaScriptObject;

// TODO : add support for Array params, and Collections
public class JavaToJSArrayUtil {
    
	public static JavaScriptObject arrayConvert(Object[] array, String[] signatures) {
        if (array.length != signatures.length) 
            throw new RuntimeException("Array.length must equal signatures.length ");
		
        JavaScriptObject result = newJSArray(array.length);
		String signature;
        for (int i = 0; i < array.length; i++) {
            signature = signatures[i];
            if (signature.length() == 0) throw new RuntimeException(" Signature not exist "); 
            if (signature.equals("Z"))
                arraySet(result, i, ((Boolean)array[i]).booleanValue());
            else if (signature.equals("B"))
                arraySet(result, i, ((Byte)array[i]).byteValue());
            else if (signature.equals("C"))
                arraySet(result, i, ((Character)array[i]).charValue());
            else if (signature.equals("S"))
                arraySet(result, i, ((Short)array[i]).shortValue());
            else if (signature.equals("I"))
                arraySet(result, i, ((Integer)array[i]).intValue());
            else if (signature.equals("J"))
                arraySet(result, i, ((Long)array[i]).longValue());
            else if (signature.equals("F"))
                arraySet(result, i, ((Float)array[i]).floatValue());
            else if (signature.equals("D"))
                arraySet(result, i, ((Double)array[i]).doubleValue());
            else if (signature.charAt(0) == 'L')
                arraySet(result, i, array[i]);
            else if (signature.charAt(0) == '[') {
                throw new UnsupportedOperationException("Translating parametrs with Array param is not implemented jet");
                //arraySet(result, i, array[i]);
            }
            else throw new UnsupportedOperationException("Unsupported signatur : " + signature);
		}
		return result;
	}
    
    public static JavaScriptObject arrayConvert(Object[] array) {
        JavaScriptObject result = newJSArray(array.length);
        for (int i = 0; i < array.length; i++) {
            arraySet(result, i, array[i]);
        }
        return result;

    }

	public static native JavaScriptObject newJSArray(int length) /*-{
	 if (length < 0) {
	 	return new Array();
	 }
	 else {
	 	return new Array(length);
	 }

	 }-*/;

	public static native int arrayLength(JavaScriptObject array) /*-{
	    return array.length;
	}-*/;

	public static native Object arrayGetObject(JavaScriptObject array, int index) /*-{
	     return array[index];
	}-*/;

	public static native void arraySet(JavaScriptObject array, int index, Object value) /*-{
        array[index] = value;
    }-*/;
    
	public static native void arraySet(JavaScriptObject array, int index, boolean value) /*-{
        array[index] = value;
	}-*/;
	public static native void arraySet(JavaScriptObject array, int index, byte  value) /*-{
        array[index] = value;
	}-*/;
	public static native void arraySet(JavaScriptObject array, int index, char  value) /*-{
        array[index] = value;
	}-*/;
	public static native void arraySet(JavaScriptObject array, int index, short  value) /*-{
        array[index] = value;
	}-*/;
	public static native void arraySet(JavaScriptObject array, int index, int  value) /*-{
        array[index] = value;
	}-*/;
	public static native void arraySet(JavaScriptObject array, int index, long  value) /*-{
        array[index] = value;
	}-*/;
	public static native void arraySet(JavaScriptObject array, int index, float  value) /*-{
        array[index] = value;
	}-*/;
	public static native void arraySet(JavaScriptObject array, int index, double value) /*-{
        array[index] = value;
	}-*/;
	
}
